FUNCTION TBrowseArray( nTr,nLc,nBr,nRc,aArray,bGetSetIndex )
   // Create a generic TBrowse
   LOCAL tb:= TBrowseNew( nTr,nLc,nBr,nRc )
   IF Eval( bGetSetIndex ) == NIL
      // Initialize Current Element
      Eval( bGetSetIndex,1 )		
   ENDIF

   // Top of array: element == 1
   tb:goTopBlock:= {|| Eval( bGetSetIndex,1 ) }

   // Bottom of array: element == length of array
   tb:goBottomBlock:= {|| Eval( bGetSetIndex,Len( aArray ) ) }

   // Movement in array: based on amount to move and current element
   tb:skipBlock:= {|nMove| SkipElement( nMove,aArray,bGetSetIndex ) }

   RETURN tb	// Return TBrowse object ready to browse array

// Static function only visible in same source file as TBrowseArray()
STATIC FUNCTION SkipElement( nMove,aArray,bIndex )

   IF nMove > 0
      // Move down requested amount or as much as possible
      nMove:= Min( nMove,Len( aArray ) - Eval( bIndex ) )
   ELSE
      // Move up requested amount or as much as possible
      nMove:= Max( nMove,1 - Eval( bIndex ) )
   ENDIF

   // Set current element to new position
   Eval( bIndex, Eval( bIndex ) + nMove )

   // Return amount moved
   RETURN nMove

